#include <algorithm>
#include <cmath>
#include <cstdio>
#include <vector>

using namespace std;

typedef pair<double, double> pdd;

const int MAXN = 1 << 17;
const double eps = 1e-7;
const double pi = 3.14159265;

int main(void) {
  int n;
  double r;
  scanf("%d%lf", &n, &r);

  vector<pair<double, double>> V;

  for (int i = 0; i < n; ++i) {
    int xi, yi;
    double ri;
    scanf("%d%d%lf", &xi, &yi, &ri);

    double dist = sqrt(xi * xi + yi * yi);
    double dangle = asin((ri + r) / dist);
    double angle = atan2(yi, xi);
    double left = max(0.0, angle - dangle);
    double right = min(pi, angle + dangle);

    V.push_back(make_pair(left, right));
  }

  sort(V.begin(), V.end(),
       [](const pdd &a, const pdd &b) { return a.second < b.second; });

  int sol = 0;
  double last = -(1 << 30);

  for (auto x : V) {
    if (last + eps < x.first) {
      last = x.second;
      ++sol;
    }
  }

  printf("%d\n", sol);
  return 0;
}
