#include <cstdio>
#include <ctime>

const int MAXN = 1510;

struct Next {
  int x;
  int y;
  int dir_x;
  int dir_y;
  long long t;
};

char board[MAXN][MAXN];
Next next[MAXN][MAXN][2][2];
long long solution[MAXN][MAXN];
int last_removed[MAXN][MAXN][2][2];

int main() {
  int n, m;
  scanf("%d%d", &n, &m);
  for (int i = 0; i < n; ++i) {
    scanf("%s", board[i]);
  }

  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < m; ++j) {
      for (int dir_i = -1; dir_i <= 1; dir_i += 2) {
        for (int dir_j = -1; dir_j <= 1; dir_j += 2) {
          int y = i, x = j;
          int dir_y = dir_i, dir_x = dir_j;
          x += dir_x;
          y += dir_y;
          if (y < 0) y = 0, dir_y = 1;
          if (x < 0) x = 0, dir_x = 1;
          if (y >= n) y = n - 1, dir_y = -1;
          if (x >= m) x = m - 1, dir_x = -1;
          auto to = [](int z) { return z == -1 ? 0 : 1; };
          next[i][j][to(dir_i)][to(dir_j)] = {x, y, to(dir_x), to(dir_y), 1};
        }
      }
    }
  }

  int y = -1, x = -1;
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < m; ++j) {
      if (board[i][j] == 'o') {
        y = i;
        x = j;
      }
    }
  }
  int dir_y = 0, dir_x = 1;
  int removed = 1;
  long long t = 0LL;
  while (true) {
    auto &nxt = next[y][x][dir_y][dir_x];
    x = nxt.x;
    y = nxt.y;
    dir_x = nxt.dir_x;
    dir_y = nxt.dir_y;
    t += nxt.t;
    if (last_removed[y][x][dir_y][dir_x] == removed) break;
    last_removed[y][x][dir_y][dir_x] = removed;
    auto cpy = next[y][x][dir_y][dir_x];
    if (board[y][x] == '-') {
      dir_y ^= 1;
    }
    if (board[y][x] == '|') {
      dir_x ^= 1;
    }
    if (board[y][x] == '-' || board[y][x] == '|') {
      board[y][x] = '.';
      ++removed;
      solution[y][x] = t;
    }
    auto t = nxt.t;
    nxt = cpy;
    nxt.t += t;
  }

  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < m; ++j) {
      printf("%lld", solution[i][j]);
      if (j != m - 1) printf(" ");
    }
    if (i != n - 1) printf("\n");
  }

  return 0;
}
